'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _create = require('babel-runtime/core-js/object/create');

var _create2 = _interopRequireDefault(_create);

exports.createPanoramaLayer = createPanoramaLayer;

var _three = require('three');

var THREE = _interopRequireWildcard(_three);

var _View = require('../View');

var _View2 = _interopRequireDefault(_View);

var _PanoramaLayer = require('./Panorama/PanoramaLayer');

var _PanoramaLayer2 = _interopRequireDefault(_PanoramaLayer);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createPanoramaLayer(id, coordinates, type) {
    var options = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};

    console.warn('createPanoramaLayer is deprecated, use the PanoramaLayer class instead.');
    return new _PanoramaLayer2.default(id, coordinates, type, options);
}

function PanoramaView(viewerDiv, coordinates, type) {
    var options = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};

    THREE.Object3D.DefaultUp.set(0, 0, 1);

    // Setup View
    _View2.default.call(this, coordinates.crs, viewerDiv, options);

    // Configure camera
    var camera = this.camera.camera3D;
    coordinates.xyz(camera.position);

    camera.fov = 45;
    camera.near = 0.1;
    camera.far = 1000;
    camera.up = coordinates.geodesicNormal;
    // look at to the north
    camera.lookAt(new THREE.Vector3(0, 1, 0).add(camera.position));

    if (camera.updateProjectionMatrix) {
        camera.updateProjectionMatrix();
    }
    camera.updateMatrixWorld();

    this.tileLayer = new _PanoramaLayer2.default('panorama', coordinates, type, options);

    _View2.default.prototype.addLayer.call(this, this.tileLayer);
}

PanoramaView.prototype = (0, _create2.default)(_View2.default.prototype);
PanoramaView.prototype.constructor = PanoramaView;

PanoramaView.prototype.addLayer = function (layer) {
    if (!layer) {
        return new _promise2.default(function (resolve, reject) {
            return reject(new Error('layer is undefined'));
        });
    }
    if (layer.type != 'color') {
        throw new Error('Unsupported layer type ' + layer.type + ' (PanoramaView only support \'color\' layers)');
    }
    return _View2.default.prototype.addLayer.call(this, layer, this.tileLayer);
};

exports.default = PanoramaView;