'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.ImageryLayers = undefined;

var _from = require('babel-runtime/core-js/array/from');

var _from2 = _interopRequireDefault(_from);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _defineProperty = require('babel-runtime/core-js/object/define-property');

var _defineProperty2 = _interopRequireDefault(_defineProperty);

var _getOwnPropertyDescriptor = require('babel-runtime/core-js/object/get-own-property-descriptor');

var _getOwnPropertyDescriptor2 = _interopRequireDefault(_getOwnPropertyDescriptor);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _three = require('three');

var THREE = _interopRequireWildcard(_three);

var _LayerUpdateStrategy = require('./LayerUpdateStrategy');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Layer = function (_THREE$EventDispatche) {
    (0, _inherits3.default)(Layer, _THREE$EventDispatche);

    /**
     * Don't use directly constructor to instance a new Layer. Instead, use
     * another available type of Layer, implement a new one inheriting from this
     * one or use {@link View#addLayer}.
     *
     * @constructor
     * @protected
     *
     * @param {string} id - The id of the layer, that should be unique. It is
     * not mandatory, but an error will be emitted if this layer is added a
     * {@link View} that already has a layer going by that id.
     * @param {string} type - The type of the layer, used to determine
     * operations to do on a layer later in the rendering loop. There are three
     * type of layers in itowns:
     * <ul>
     *  <li><code>color</code>, used for simple layer containing a texture</li>
     *  <li><code>elevation</code>, used for adding an elevation to the globe or
     *  plane the layer is attached to</li>
     *  <li><code>geometry</code>, used for complex layer containing meshes,
     *  like a WFS layer with extruded buildings</li>
     * <ul>
     * @param {Object} [config] - Optional configuration, all elements in it
     * will be merged as is in the layer. For example, if the configuration
     * contains three elements <code>name, protocol, extent</code>, these
     * elements will be available using <code>layer.name</code> or something
     * else depending on the property name.
     *
     * @example
     * // Add and create a new Layer
     * const newLayer = view.addLayer({options});
     *
     * // Change layer's visibilty
     * const layerToChange = view.getLayers(layer => layer.id == 'idLayerToChange')[0];
     * layerToChange.visible = false;
     * view.notifyChange(); // update viewer
     *
     * // Change layer's opacity
     * const layerToChange = view.getLayers(layer => layer.id == 'idLayerToChange')[0];
     * layerToChange.opacity = 0.5;
     * view.notifyChange(); // update viewer
     *
     * // Listen properties
     * const layerToListen = view.getLayers(layer => layer.id == 'idLayerToListen')[0];
     * layerToListen.addEventListener('visible-property-changed', (event) => console.log(event));
     * layerToListen.addEventListener('opacity-property-changed', (event) => console.log(event));
     */
    function Layer(id, type) {
        var config = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
        (0, _classCallCheck3.default)(this, Layer);

        var _this = (0, _possibleConstructorReturn3.default)(this, (Layer.__proto__ || (0, _getPrototypeOf2.default)(Layer)).call(this));

        (0, _assign2.default)(_this, config);

        Object.defineProperty(_this, 'id', {
            value: id,
            writable: false
        });

        Object.defineProperty(_this, 'type', {
            value: type,
            writable: false
        });

        // Default properties
        _this.options = config.options || {};

        if (!_this.updateStrategy) {
            _this.updateStrategy = {
                type: _LayerUpdateStrategy.STRATEGY_MIN_NETWORK_TRAFFIC,
                options: {}
            };
        }

        // TODO remove this warning and fallback after the release following v2.3.0
        if (!_this.format && _this.options.mimetype) {
            console.warn('layer.options.mimetype is deprecated, please use layer.format');
            _this.format = _this.options.mimetype;
        }

        _this.defineLayerProperty('frozen', false);
        return _this;
    }

    /**
     * Defines a property for this layer, with a default value and a callback
     * executed when the property changes.
     * <br><br>
     * When changing the property, it also emits an event, named following this
     * convention: <code>${propertyName}-property-changed</code>, with
     * <code>${propertyName}</code> being replaced by the name of the property.
     * For example, if the added property name is <code>frozen</code>, it will
     * emit a <code>frozen-property-changed</code>.
     * <br><br>
     * @example <caption>The emitted event has some properties assigned to it</caption>
     * event = {
     *     new: {
     *         ${propertyName}: * // the new value of the property
     *     },
     *     previous: {
     *         ${propertyName}: * // the previous value of the property
     *     },
     *     target: Layer // the layer it has been dispatched from
     *     type: string // the name of the emitted event
     * }
     *
     * @param {string} propertyName - The name of the property, also used in
     * the emitted event name.
     * @param {*} defaultValue - The default set value.
     * @param {function} [onChange] - The function executed when the property is
     * changed. Parameters are the layer the property is defined on, and the
     * name of the property.
     */


    (0, _createClass3.default)(Layer, [{
        key: 'defineLayerProperty',
        value: function defineLayerProperty(propertyName, defaultValue, onChange) {
            var _this2 = this;

            var existing = (0, _getOwnPropertyDescriptor2.default)(this, propertyName);
            if (!existing || !existing.set) {
                var property = this[propertyName] == undefined ? defaultValue : this[propertyName];

                (0, _defineProperty2.default)(this, propertyName, {
                    get: function get() {
                        return property;
                    },
                    set: function set(newValue) {
                        if (property !== newValue) {
                            var event = { type: propertyName + '-property-changed', previous: {}, new: {} };
                            event.previous[propertyName] = property;
                            event.new[propertyName] = newValue;
                            property = newValue;
                            if (onChange) {
                                onChange(_this2, propertyName);
                            }
                            _this2.dispatchEvent(event);
                        }
                    }
                });
            }
        }
    }]);
    return Layer;
}(THREE.EventDispatcher);

exports.default = Layer;
var ImageryLayers = exports.ImageryLayers = {
    // move this to new index
    // After the modification :
    //      * the minimum sequence will always be 0
    //      * the maximum sequence will always be layers.lenght - 1
    // the ordering of all layers (Except that specified) doesn't change
    moveLayerToIndex: function (layer, newIndex, imageryLayers) {
        newIndex = Math.min(newIndex, imageryLayers.length - 1);
        newIndex = Math.max(newIndex, 0);
        var oldIndex = layer.sequence;

        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
            for (var _iterator = (0, _getIterator3.default)(imageryLayers), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                var imagery = _step.value;

                if (imagery.id === layer.id) {
                    // change index of specified layer
                    imagery.sequence = newIndex;
                } else if (imagery.sequence > oldIndex && imagery.sequence <= newIndex) {
                    // down all layers between the old index and new index (to compensate the deletion of the old index)
                    imagery.sequence--;
                } else if (imagery.sequence >= newIndex && imagery.sequence < oldIndex) {
                    // up all layers between the new index and old index (to compensate the insertion of the new index)
                    imagery.sequence++;
                }
            }
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally {
            try {
                if (!_iteratorNormalCompletion && _iterator.return) {
                    _iterator.return();
                }
            } finally {
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
    },

    moveLayerDown: function (layer, imageryLayers) {
        if (layer.sequence > 0) {
            this.moveLayerToIndex(layer, layer.sequence - 1, imageryLayers);
        }
    },

    moveLayerUp: function (layer, imageryLayers) {
        var m = imageryLayers.length - 1;
        if (layer.sequence < m) {
            this.moveLayerToIndex(layer, layer.sequence + 1, imageryLayers);
        }
    },

    getColorLayersIdOrderedBySequence: function (imageryLayers) {
        var copy = (0, _from2.default)(imageryLayers);
        copy.sort(function (a, b) {
            return a.sequence - b.sequence;
        });
        return copy.map(function (l) {
            return l.id;
        });
    }
};