'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _Utf8Decoder = require('../utils/Utf8Decoder');

var _Utf8Decoder2 = _interopRequireDefault(_Utf8Decoder);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
    /** @module BatchTableParser */
    /** Parse batch table buffer and convert to JSON
     * @function parse
     * @param {ArrayBuffer} buffer - the batch table buffer.
     * @return {Promise} - a promise that resolves with a JSON object.
     *
     */
    parse: function parse(buffer) {
        var content = _Utf8Decoder2.default.decode(new Uint8Array(buffer));
        var json = JSON.parse(content);
        return _promise2.default.resolve(json);
    }
};