'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _three = require('three');

var THREE = _interopRequireWildcard(_three);

var _TileGeometry = require('../Core/TileGeometry');

var _TileGeometry2 = _interopRequireDefault(_TileGeometry);

var _TileMesh = require('../Core/TileMesh');

var _TileMesh2 = _interopRequireDefault(_TileMesh);

var _LayeredMaterial = require('../Renderer/LayeredMaterial');

var _LayeredMaterial2 = _interopRequireDefault(_LayeredMaterial);

var _Cache = require('../Core/Scheduler/Cache');

var _Cache2 = _interopRequireDefault(_Cache);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
    convert: function convert(requester, extent, layer) {
        var builder = layer.builder;
        var parent = requester;
        var level = parent !== undefined ? parent.level + 1 : 0;

        var _builder$computeShara = builder.computeSharableExtent(extent),
            sharableExtent = _builder$computeShara.sharableExtent,
            quaternion = _builder$computeShara.quaternion,
            position = _builder$computeShara.position;

        var south = sharableExtent.south().toFixed(6);
        var segment = layer.options.segments || 16;
        var key = builder.type + '_' + (layer.disableSkirt ? 0 : 1) + '_' + segment + '_' + level + '_' + south;

        var geometry = _Cache2.default.get(key);
        // build geometry if doesn't exist
        if (!geometry) {
            var paramsGeometry = {
                extent: sharableExtent,
                level: level,
                segment: segment,
                disableSkirt: layer.disableSkirt
            };

            geometry = new _TileGeometry2.default(paramsGeometry, builder);
            _Cache2.default.set(key, geometry);

            geometry._count = 0;
            geometry.dispose = function () {
                geometry._count--;
                if (geometry._count == 0) {
                    THREE.BufferGeometry.prototype.dispose.call(geometry);
                    _Cache2.default.delete(key);
                }
            };
        }

        // build tile
        geometry._count++;
        var material = new _LayeredMaterial2.default(layer.materialOptions);
        var tile = new _TileMesh2.default(layer, geometry, material, extent, level);
        // TODO semble ne pas etre necessaire
        tile.layers.set(layer.threejsLayer);

        if (parent && parent instanceof _TileMesh2.default) {
            // get parent extent transformation
            var pTrans = builder.computeSharableExtent(parent.extent);
            // place relative to his parent
            position.sub(pTrans.position).applyQuaternion(pTrans.quaternion.inverse());
            quaternion.premultiply(pTrans.quaternion);
        }

        tile.position.copy(position);
        tile.quaternion.copy(quaternion);

        tile.material.transparent = layer.opacity < 1.0;
        tile.material.uniforms.opacity.value = layer.opacity;
        tile.setVisibility(false);
        tile.updateMatrix();

        if (parent) {
            tile.setBBoxZ(parent.obb.z.min, parent.obb.z.max);
        } else if (layer.materialOptions && layer.materialOptions.useColorTextureElevation) {
            tile.setBBoxZ(layer.materialOptions.colorTextureElevationMinZ, layer.materialOptions.colorTextureElevationMaxZ);
        }

        tile.add(tile.obb);

        tile.material.setLightingOn(layer.lighting.enable);
        tile.material.uniforms.lightPosition.value = layer.lighting.position;

        if (layer.noTextureColor) {
            tile.material.uniforms.noTextureColor.value.copy(layer.noTextureColor);
        }

        return _promise2.default.resolve(tile);
    }
}; /*
    * To change this license header, choose License Headers in Project Properties.
    * To change this template file, choose Tools | Templates
    * and open the template in the editor.
    */