'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _CancelledCommandException = require('../Core/Scheduler/CancelledCommandException');

var _CancelledCommandException2 = _interopRequireDefault(_CancelledCommandException);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
    executeCommand: function executeCommand(command) {
        var promises = [];
        var layer = command.layer;
        var requester = command.requester;
        var extentsSource = command.extentsSource;

        if (requester && !requester.material) {
            return _promise2.default.reject(new _CancelledCommandException2.default(command));
        }

        for (var i = 0, size = extentsSource.length; i < size; i++) {
            promises.push(layer.convert(requester, extentsSource[i]));
        }

        return _promise2.default.all(promises);
    }
};